/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

/** @module test-js/test_connection_with_close_future */
var utils = require('vertx-js/util/utils');

var io = Packages.io;
var JsonObject = io.vertx.core.json.JsonObject;
var JTestConnectionWithCloseFuture = Java.type('io.vertx.serviceproxy.testmodel.TestConnectionWithCloseFuture');

/**

 @class
*/
var TestConnectionWithCloseFuture = function(j_val) {

  var j_testConnectionWithCloseFuture = j_val;
  var that = this;

  /**

   @public
   @param handler {function} 
   */
  this.close = function(handler) {
    var __args = arguments;
    if (__args.length === 1 && typeof __args[0] === 'function') {
      j_testConnectionWithCloseFuture["close(io.vertx.core.Handler)"](function(ar) {
      if (ar.succeeded()) {
        handler(null, null);
      } else {
        handler(null, ar.cause());
      }
    });
    } else throw new TypeError('function invoked with invalid arguments');
  };

  /**

   @public
   @param resultHandler {function} 
   */
  this.someMethod = function(resultHandler) {
    var __args = arguments;
    if (__args.length === 1 && typeof __args[0] === 'function') {
      j_testConnectionWithCloseFuture["someMethod(io.vertx.core.Handler)"](function(ar) {
      if (ar.succeeded()) {
        resultHandler(ar.result(), null);
      } else {
        resultHandler(null, ar.cause());
      }
    });
    } else throw new TypeError('function invoked with invalid arguments');
  };

  // A reference to the underlying Java delegate
  // NOTE! This is an internal API and must not be used in user code.
  // If you rely on this property your code is likely to break if we change it / remove it without warning.
  this._jdel = j_testConnectionWithCloseFuture;
};

TestConnectionWithCloseFuture._jclass = utils.getJavaClass("io.vertx.serviceproxy.testmodel.TestConnectionWithCloseFuture");
TestConnectionWithCloseFuture._jtype = {
  accept: function(obj) {
    return TestConnectionWithCloseFuture._jclass.isInstance(obj._jdel);
  },
  wrap: function(jdel) {
    var obj = Object.create(TestConnectionWithCloseFuture.prototype, {});
    TestConnectionWithCloseFuture.apply(obj, arguments);
    return obj;
  },
  unwrap: function(obj) {
    return obj._jdel;
  }
};
TestConnectionWithCloseFuture._create = function(jdel) {
  var obj = Object.create(TestConnectionWithCloseFuture.prototype, {});
  TestConnectionWithCloseFuture.apply(obj, arguments);
  return obj;
}
module.exports = TestConnectionWithCloseFuture;